Index: src/lemon/dijkstra.h
===================================================================
--- src/lemon/dijkstra.h	(revision 1201)
+++ src/lemon/dijkstra.h	(revision 1218)
@@ -77,38 +77,39 @@
       return new PredMap(G);
     }
-    ///\brief The type of the map that stores the last but one
-    ///nodes of the shortest paths.
-    ///
-    ///The type of the map that stores the last but one
-    ///nodes of the shortest paths.
-    ///It must meet the \ref concept::WriteMap "WriteMap" concept.
-    ///
-    typedef NullMap<typename Graph::Node,typename Graph::Node> PredNodeMap;
-    ///Instantiates a PredNodeMap.
-    
-    ///This function instantiates a \ref PredNodeMap. 
-    ///\param G is the graph, to which
-    ///we would like to define the \ref PredNodeMap
-    static PredNodeMap *createPredNodeMap(const GR &G)
-    {
-      return new PredNodeMap();
-    }
-
-    ///The type of the map that stores whether a nodes is reached.
- 
-    ///The type of the map that stores whether a nodes is reached.
+//     ///\brief The type of the map that stores the last but one
+//     ///nodes of the shortest paths.
+//     ///
+//     ///The type of the map that stores the last but one
+//     ///nodes of the shortest paths.
+//     ///It must meet the \ref concept::WriteMap "WriteMap" concept.
+//     ///
+//     typedef NullMap<typename Graph::Node,typename Graph::Node> PredNodeMap;
+//     ///Instantiates a PredNodeMap.
+    
+//     ///This function instantiates a \ref PredNodeMap. 
+//     ///\param G is the graph, to which
+//     ///we would like to define the \ref PredNodeMap
+//     static PredNodeMap *createPredNodeMap(const GR &G)
+//     {
+//       return new PredNodeMap();
+//     }
+
+    ///The type of the map that stores whether a nodes is processed.
+ 
+    ///The type of the map that stores whether a nodes is processed.
     ///It must meet the \ref concept::WriteMap "WriteMap" concept.
     ///By default it is a NullMap.
-    ///\todo If it is set to a real map, Dijkstra::reached() should read this.
+    ///\todo If it is set to a real map,
+    ///Dijkstra::processed() should read this.
     ///\todo named parameter to set this type, function to read and write.
-    typedef NullMap<typename Graph::Node,bool> ReachedMap;
-    ///Instantiates a ReachedMap.
- 
-    ///This function instantiates a \ref ReachedMap. 
+    typedef NullMap<typename Graph::Node,bool> ProcessedMap;
+    ///Instantiates a ProcessedMap.
+ 
+    ///This function instantiates a \ref ProcessedMap. 
     ///\param G is the graph, to which
-    ///we would like to define the \ref ReachedMap
-    static ReachedMap *createReachedMap(const GR &G)
-    {
-      return new ReachedMap();
+    ///we would like to define the \ref ProcessedMap
+    static ProcessedMap *createProcessedMap(const GR &G)
+    {
+      return new ProcessedMap();
     }
     ///The type of the map that stores the dists of the nodes.
@@ -141,21 +142,19 @@
   ///It is also possible to change the underlying priority heap.
   ///
-  ///\param GR The graph type the algorithm runs on. The default value is
-  ///\ref ListGraph. The value of GR is not used directly by Dijkstra, it
-  ///is only passed to \ref DijkstraDefaultTraits.
-  ///\param LM This read-only
-  ///EdgeMap
-  ///determines the
-  ///lengths of the edges. It is read once for each edge, so the map
-  ///may involve in relatively time consuming process to compute the edge
-  ///length if it is necessary. The default map type is
-  ///\ref concept::StaticGraph::EdgeMap "Graph::EdgeMap<int>".
-  ///The value of LM is not used directly by Dijkstra, it
-  ///is only passed to \ref DijkstraDefaultTraits.
-  ///\param TR Traits class to set various data types used by the algorithm.
-  ///The default traits class is
-  ///\ref DijkstraDefaultTraits "DijkstraDefaultTraits<GR,LM>".
-  ///See \ref DijkstraDefaultTraits for the documentation of
-  ///a Dijkstra traits class.
+  ///\param GR The graph type the algorithm runs on. The default value
+  ///is \ref ListGraph. The value of GR is not used directly by
+  ///Dijkstra, it is only passed to \ref DijkstraDefaultTraits.
+  ///\param LM This read-only EdgeMap determines the lengths of the
+  ///edges. It is read once for each edge, so the map may involve in
+  ///relatively time consuming process to compute the edge length if
+  ///it is necessary. The default map type is \ref
+  ///concept::StaticGraph::EdgeMap "Graph::EdgeMap<int>".  The value
+  ///of LM is not used directly by Dijkstra, it is only passed to \ref
+  ///DijkstraDefaultTraits.  \param TR Traits class to set
+  ///various data types used by the algorithm.  The default traits
+  ///class is \ref DijkstraDefaultTraits
+  ///"DijkstraDefaultTraits<GR,LM>".  See \ref
+  ///DijkstraDefaultTraits for the documentation of a Dijkstra traits
+  ///class.
   ///
   ///\author Jacint Szabo and Alpar Juttner
@@ -182,5 +181,5 @@
     public:
       virtual const char* exceptionName() const {
-	return "lemon::Dijsktra::UninitializedParameter";
+	return "lemon::Dijkstra::UninitializedParameter";
       }
     };
@@ -205,9 +204,9 @@
     ///edges of the shortest paths.
     typedef typename TR::PredMap PredMap;
-    ///\brief The type of the map that stores the last but one
-    ///nodes of the shortest paths.
-    typedef typename TR::PredNodeMap PredNodeMap;
-    ///The type of the map indicating if a node is reached.
-    typedef typename TR::ReachedMap ReachedMap;
+//     ///\brief The type of the map that stores the last but one
+//     ///nodes of the shortest paths.
+//     typedef typename TR::PredNodeMap PredNodeMap;
+    ///The type of the map indicating if a node is processed.
+    typedef typename TR::ProcessedMap ProcessedMap;
     ///The type of the map that stores the dists of the nodes.
     typedef typename TR::DistMap DistMap;
@@ -223,19 +222,19 @@
     ///Indicates if \ref _pred is locally allocated (\c true) or not.
     bool local_pred;
-    ///Pointer to the map of predecessors nodes.
-    PredNodeMap *_predNode;
-    ///Indicates if \ref _predNode is locally allocated (\c true) or not.
-    bool local_predNode;
+//     ///Pointer to the map of predecessors nodes.
+//     PredNodeMap *_predNode;
+//     ///Indicates if \ref _predNode is locally allocated (\c true) or not.
+//     bool local_predNode;
     ///Pointer to the map of distances.
     DistMap *_dist;
     ///Indicates if \ref _dist is locally allocated (\c true) or not.
     bool local_dist;
-    ///Pointer to the map of reached status of the nodes.
-    ReachedMap *_reached;
-    ///Indicates if \ref _reached is locally allocated (\c true) or not.
-    bool local_reached;
-
-    ///The source node of the last execution.
-    Node source;
+    ///Pointer to the map of processed status of the nodes.
+    ProcessedMap *_processed;
+    ///Indicates if \ref _processed is locally allocated (\c true) or not.
+    bool local_processed;
+
+//     ///The source node of the last execution.
+//     Node source;
 
     ///Creates the maps if necessary.
@@ -249,15 +248,15 @@
 	_pred = Traits::createPredMap(*G);
       }
-      if(!_predNode) {
-	local_predNode = true;
-	_predNode = Traits::createPredNodeMap(*G);
-      }
+//       if(!_predNode) {
+// 	local_predNode = true;
+// 	_predNode = Traits::createPredNodeMap(*G);
+//       }
       if(!_dist) {
 	local_dist = true;
 	_dist = Traits::createDistMap(*G);
       }
-      if(!_reached) {
-	local_reached = true;
-	_reached = Traits::createReachedMap(*G);
+      if(!_processed) {
+	local_processed = true;
+	_processed = Traits::createProcessedMap(*G);
       }
     }
@@ -286,20 +285,20 @@
 					DefPredMapTraits<T> > { };
     
-    template <class T>
-    struct DefPredNodeMapTraits : public Traits {
-      typedef T PredNodeMap;
-      static PredNodeMap *createPredNodeMap(const Graph &G) 
-      {
-	throw UninitializedParameter();
-      }
-    };
-    ///\ref named-templ-param "Named parameter" for setting PredNodeMap type
-
-    ///\ref named-templ-param "Named parameter" for setting PredNodeMap type
-    ///
-    template <class T>
-    class DefPredNodeMap : public Dijkstra< Graph,
-					    LengthMap,
-					    DefPredNodeMapTraits<T> > { };
+//     template <class T>
+//     struct DefPredNodeMapTraits : public Traits {
+//       typedef T PredNodeMap;
+//       static PredNodeMap *createPredNodeMap(const Graph &G) 
+//       {
+// 	throw UninitializedParameter();
+//       }
+//     };
+//     ///\ref named-templ-param "Named parameter" for setting PredNodeMap type
+
+//     ///\ref named-templ-param "Named parameter" for setting PredNodeMap type
+//     ///
+//     template <class T>
+//     class DefPredNodeMap : public Dijkstra< Graph,
+// 					    LengthMap,
+// 					    DefPredNodeMapTraits<T> > { };
     
     template <class T>
@@ -321,38 +320,38 @@
     
     template <class T>
-    struct DefReachedMapTraits : public Traits {
-      typedef T ReachedMap;
-      static ReachedMap *createReachedMap(const Graph &G) 
+    struct DefProcessedMapTraits : public Traits {
+      typedef T ProcessedMap;
+      static ProcessedMap *createProcessedMap(const Graph &G) 
       {
 	throw UninitializedParameter();
       }
     };
-    ///\ref named-templ-param "Named parameter" for setting ReachedMap type
-
-    ///\ref named-templ-param "Named parameter" for setting ReachedMap type
+    ///\ref named-templ-param "Named parameter" for setting ProcessedMap type
+
+    ///\ref named-templ-param "Named parameter" for setting ProcessedMap type
     ///
     template <class T>
-    class DefReachedMap : public Dijkstra< Graph,
+    class DefProcessedMap : public Dijkstra< Graph,
 					LengthMap,
-					DefReachedMapTraits<T> > { };
-    
-    struct DefGraphReachedMapTraits : public Traits {
-      typedef typename Graph::template NodeMap<bool> ReachedMap;
-      static ReachedMap *createReachedMap(const Graph &G) 
+					DefProcessedMapTraits<T> > { };
+    
+    struct DefGraphProcessedMapTraits : public Traits {
+      typedef typename Graph::template NodeMap<bool> ProcessedMap;
+      static ProcessedMap *createProcessedMap(const Graph &G) 
       {
-	return new ReachedMap(G);
+	return new ProcessedMap(G);
       }
     };
     ///\brief \ref named-templ-param "Named parameter"
-    ///for setting the ReachedMap type to be Graph::NodeMap<bool>.
+    ///for setting the ProcessedMap type to be Graph::NodeMap<bool>.
     ///
     ///\ref named-templ-param "Named parameter"
-    ///for setting the ReachedMap type to be Graph::NodeMap<bool>.
+    ///for setting the ProcessedMap type to be Graph::NodeMap<bool>.
     ///If you don't set it explicitely, it will be automatically allocated.
     template <class T>
-    class DefReachedMapToBeDefaultMap :
+    class DefProcessedMapToBeDefaultMap :
       public Dijkstra< Graph,
 		       LengthMap,
-		       DefGraphReachedMapTraits> { };
+		       DefGraphProcessedMapTraits> { };
     
     ///@}
@@ -371,7 +370,7 @@
       G(&_G), length(&_length),
       _pred(NULL), local_pred(false),
-      _predNode(NULL), local_predNode(false),
+//       _predNode(NULL), local_predNode(false),
       _dist(NULL), local_dist(false),
-      _reached(NULL), local_reached(false),
+      _processed(NULL), local_processed(false),
       _heap_map(*G,-1),_heap(_heap_map)
     { }
@@ -381,7 +380,7 @@
     {
       if(local_pred) delete _pred;
-      if(local_predNode) delete _predNode;
+//       if(local_predNode) delete _predNode;
       if(local_dist) delete _dist;
-      if(local_reached) delete _reached;
+      if(local_processed) delete _processed;
     }
 
@@ -413,20 +412,20 @@
     }
 
-    ///Sets the map storing the predecessor nodes.
-
-    ///Sets the map storing the predecessor nodes.
-    ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destuctor deallocates this
-    ///automatically allocated map, of course.
-    ///\return <tt> (*this) </tt>
-    Dijkstra &predNodeMap(PredNodeMap &m) 
-    {
-      if(local_predNode) {
-	delete _predNode;
-	local_predNode=false;
-      }
-      _predNode = &m;
-      return *this;
-    }
+//     ///Sets the map storing the predecessor nodes.
+
+//     ///Sets the map storing the predecessor nodes.
+//     ///If you don't use this function before calling \ref run(),
+//     ///it will allocate one. The destuctor deallocates this
+//     ///automatically allocated map, of course.
+//     ///\return <tt> (*this) </tt>
+//     Dijkstra &predNodeMap(PredNodeMap &m) 
+//     {
+//       if(local_predNode) {
+// 	delete _predNode;
+// 	local_predNode=false;
+//       }
+//       _predNode = &m;
+//       return *this;
+//     }
 
     ///Sets the map storing the distances calculated by the algorithm.
@@ -450,17 +449,19 @@
     void finalizeNodeData(Node v,Value dst)
     {
-      _reached->set(v,true);
+      _processed->set(v,true);
       _dist->set(v, dst);
-      if((*_pred)[v]!=INVALID) _predNode->set(v,G->source((*_pred)[v])); ///\todo What to do?
+//       if((*_pred)[v]!=INVALID)
+//       _predNode->set(v,G->source((*_pred)[v])); ///\todo What to do?
     }
 
   public:
-    ///\name Excetution control
+    ///\name Execution control
     ///The simplest way to execute the algorithm is to use
     ///one of the member functions called \c run(...).
     ///\n
-    ///It you need more control on the execution,
+    ///If you need more control on the execution,
     ///first you must call \ref init(), then you can add several source nodes
-    ///with \ref addSource(). Finally \ref start() will perform the actual path
+    ///with \ref addSource().
+    ///Finally \ref start() will perform the actual path
     ///computation.
 
@@ -478,6 +479,6 @@
       for ( NodeIt u(*G) ; u!=INVALID ; ++u ) {
 	_pred->set(u,INVALID);
-	_predNode->set(u,INVALID);
-	///\todo *_reached is not set to false.
+// 	_predNode->set(u,INVALID);
+	_processed->set(u,false);
 	_heap_map.set(u,Heap::PRE_HEAP);
       }
@@ -495,5 +496,5 @@
     void addSource(Node s,Value dst=0)
     {
-      source = s;
+//       source = s;
       if(_heap.state(s) != Heap::IN_HEAP) _heap.push(s,dst);
       else if(_heap[s]<dst) {
@@ -536,14 +537,15 @@
     }
 
-    ///Returns \c false if there are nodes to be processed in the priority heap
-
-    ///Returns \c false if there are nodes to be processed in the priority heap
-    ///
-    bool emptyHeap() { return _heap.empty(); }
+    ///\brief Returns \c false if there are nodes
+    ///to be processed in the priority heap
+    ///
+    ///Returns \c false if there are nodes
+    ///to be processed in the priority heap
+    bool emptyQueue() { return _heap.empty(); }
     ///Returns the number of the nodes to be processed in the priority heap
 
     ///Returns the number of the nodes to be processed in the priority heap
     ///
-    int heapSize() { return _heap.size(); }
+    int queueSize() { return _heap.size(); }
     
     ///Executes the algorithm.
@@ -697,23 +699,105 @@
     const PredMap &predMap() const { return *_pred;}
  
-    ///Returns a reference to the map of nodes of shortest paths.
-
-    ///Returns a reference to the NodeMap of the last but one nodes of the
-    ///shortest path tree.
+//     ///Returns a reference to the map of nodes of shortest paths.
+
+//     ///Returns a reference to the NodeMap of the last but one nodes of the
+//     ///shortest path tree.
+//     ///\pre \ref run() must be called before using this function.
+//     const PredNodeMap &predNodeMap() const { return *_predNode;}
+
+    ///Checks if a node is reachable from the root.
+
+    ///Returns \c true if \c v is reachable from the root.
+    ///\warning The source nodes are inditated as unreached.
     ///\pre \ref run() must be called before using this function.
-    const PredNodeMap &predNodeMap() const { return *_predNode;}
-
-    ///Checks if a node is reachable from the root.
-
-    ///Returns \c true if \c v is reachable from the root.
-    ///\warning If the algorithm is started from multiple nodes,
-    ///this function may give false result for the source nodes.
-    ///\pre \ref run() must be called before using this function.
-    ///
-    bool reached(Node v) { return v==source || (*_pred)[v]!=INVALID; }
+    ///
+    bool reached(Node v) { return _heap_map[v]!=Heap::PRE_HEAP; }
     
     ///@}
   };
 
+
+
+
+ 
+  ///Default traits class of Dijkstra function.
+
+  ///Default traits class of Dijkstra function.
+  ///\param GR Graph type.
+  ///\param LM Type of length map.
+  template<class GR, class LM>
+  struct DijkstraWizardDefaultTraits
+  {
+    ///The graph type the algorithm runs on. 
+    typedef GR Graph;
+    ///The type of the map that stores the edge lengths.
+
+    ///The type of the map that stores the edge lengths.
+    ///It must meet the \ref concept::ReadMap "ReadMap" concept.
+    typedef LM LengthMap;
+    //The type of the length of the edges.
+    typedef typename LM::Value Value;
+    ///The heap type used by Dijkstra algorithm.
+
+    ///The heap type used by Dijkstra algorithm.
+    ///
+    ///\sa BinHeap
+    ///\sa Dijkstra
+    typedef BinHeap<typename Graph::Node,
+		    typename LM::Value,
+		    typename GR::template NodeMap<int>,
+		    std::less<Value> > Heap;
+
+    ///\brief The type of the map that stores the last
+    ///edges of the shortest paths.
+    /// 
+    ///The type of the map that stores the last
+    ///edges of the shortest paths.
+    ///It must meet the \ref concept::WriteMap "WriteMap" concept.
+    ///
+    typedef NullMap <typename GR::Node,typename GR::Edge> PredMap;
+    ///Instantiates a PredMap.
+ 
+    ///This function instantiates a \ref PredMap. 
+    ///\param G is the graph, to which we would like to define the PredMap.
+    ///\todo The graph alone may be insufficient for the initialization
+    static PredMap *createPredMap(const GR &G) 
+    {
+      return new PredMap();
+    }
+    ///The type of the map that stores whether a nodes is processed.
+ 
+    ///The type of the map that stores whether a nodes is processed.
+    ///It must meet the \ref concept::WriteMap "WriteMap" concept.
+    ///By default it is a NullMap.
+    ///\todo If it is set to a real map,
+    ///Dijkstra::processed() should read this.
+    ///\todo named parameter to set this type, function to read and write.
+    typedef NullMap<typename Graph::Node,bool> ProcessedMap;
+    ///Instantiates a ProcessedMap.
+ 
+    ///This function instantiates a \ref ProcessedMap. 
+    ///\param G is the graph, to which
+    ///we would like to define the \ref ProcessedMap
+    static ProcessedMap *createProcessedMap(const GR &G)
+    {
+      return new ProcessedMap();
+    }
+    ///The type of the map that stores the dists of the nodes.
+ 
+    ///The type of the map that stores the dists of the nodes.
+    ///It must meet the \ref concept::WriteMap "WriteMap" concept.
+    ///
+    typedef NullMap<typename Graph::Node,typename LM::Value> DistMap;
+    ///Instantiates a DistMap.
+ 
+    ///This function instantiates a \ref DistMap. 
+    ///\param G is the graph, to which we would like to define the \ref DistMap
+    static DistMap *createDistMap(const GR &G)
+    {
+      return new DistMap();
+    }
+  };
+  
   /// Default traits used by \ref DijkstraWizard
 
@@ -725,8 +809,8 @@
   /// \ref DijkstraWizard class.
   template<class GR,class LM>
-  class DijkstraWizardBase : public DijkstraDefaultTraits<GR,LM>
+  class DijkstraWizardBase : public DijkstraWizardDefaultTraits<GR,LM>
   {
 
-    typedef DijkstraDefaultTraits<GR,LM> Base;
+    typedef DijkstraWizardDefaultTraits<GR,LM> Base;
   protected:
     /// Type of the nodes in the graph.
@@ -739,6 +823,6 @@
     ///Pointer to the map of predecessors edges.
     void *_pred;
-    ///Pointer to the map of predecessors nodes.
-    void *_predNode;
+//     ///Pointer to the map of predecessors nodes.
+//     void *_predNode;
     ///Pointer to the map of distances.
     void *_dist;
@@ -751,6 +835,7 @@
     /// This constructor does not require parameters, therefore it initiates
     /// all of the attributes to default values (0, INVALID).
-    DijkstraWizardBase() : _g(0), _length(0), _pred(0), _predNode(0),
-		       _dist(0), _source(INVALID) {}
+    DijkstraWizardBase() : _g(0), _length(0), _pred(0),
+// 			   _predNode(0),
+			   _dist(0), _source(INVALID) {}
 
     /// Constructor.
@@ -763,6 +848,7 @@
     /// \param s is the initial value of  \ref _source
     DijkstraWizardBase(const GR &g,const LM &l, Node s=INVALID) :
-      _g((void *)&g), _length((void *)&l), _pred(0), _predNode(0),
-		  _dist(0), _source(s) {}
+      _g((void *)&g), _length((void *)&l), _pred(0),
+//       _predNode(0),
+      _dist(0), _source(s) {}
 
   };
@@ -770,5 +856,4 @@
   /// A class to make easier the usage of Dijkstra algorithm
 
-  /// \ingroup flowalgs
   /// This class is created to make it easier to use Dijkstra algorithm.
   /// It uses the functions and features of the plain \ref Dijkstra,
@@ -811,7 +896,7 @@
     ///edges of the shortest paths.
     typedef typename TR::PredMap PredMap;
-    ///\brief The type of the map that stores the last but one
-    ///nodes of the shortest paths.
-    typedef typename TR::PredNodeMap PredNodeMap;
+//     ///\brief The type of the map that stores the last but one
+//     ///nodes of the shortest paths.
+//     typedef typename TR::PredNodeMap PredNodeMap;
     ///The type of the map that stores the dists of the nodes.
     typedef typename TR::DistMap DistMap;
@@ -845,5 +930,5 @@
 	Dij(*(Graph*)Base::_g,*(LengthMap*)Base::_length);
       if(Base::_pred) Dij.predMap(*(PredMap*)Base::_pred);
-      if(Base::_predNode) Dij.predNodeMap(*(PredNodeMap*)Base::_predNode);
+//       if(Base::_predNode) Dij.predNodeMap(*(PredNodeMap*)Base::_predNode);
       if(Base::_dist) Dij.distMap(*(DistMap*)Base::_dist);
       Dij.run(Base::_source);
@@ -881,23 +966,23 @@
     
 
-    template<class T>
-    struct DefPredNodeMapBase : public Base {
-      typedef T PredNodeMap;
-      static PredNodeMap *createPredNodeMap(const Graph &G) { return 0; };
-      DefPredNodeMapBase(const Base &b) : Base(b) {}
-    };
-    
-    ///\brief \ref named-templ-param "Named parameter"
-    ///function for setting PredNodeMap type
-    ///
-    /// \ref named-templ-param "Named parameter"
-    ///function for setting PredNodeMap type
-    ///
-    template<class T>
-    DijkstraWizard<DefPredNodeMapBase<T> > predNodeMap(const T &t) 
-    {
-      Base::_predNode=(void *)&t;
-      return DijkstraWizard<DefPredNodeMapBase<T> >(*this);
-    }
+//     template<class T>
+//     struct DefPredNodeMapBase : public Base {
+//       typedef T PredNodeMap;
+//       static PredNodeMap *createPredNodeMap(const Graph &G) { return 0; };
+//       DefPredNodeMapBase(const Base &b) : Base(b) {}
+//     };
+    
+//     ///\brief \ref named-templ-param "Named parameter"
+//     ///function for setting PredNodeMap type
+//     ///
+//     /// \ref named-templ-param "Named parameter"
+//     ///function for setting PredNodeMap type
+//     ///
+//     template<class T>
+//     DijkstraWizard<DefPredNodeMapBase<T> > predNodeMap(const T &t) 
+//     {
+//       Base::_predNode=(void *)&t;
+//       return DijkstraWizard<DefPredNodeMapBase<T> >(*this);
+//     }
    
     template<class T>
@@ -933,9 +1018,21 @@
   };
   
-  ///\e
+  ///Function type interface for Dijkstra algorithm.
 
   /// \ingroup flowalgs
-  ///\todo Please document...
+  ///Function type interface for Dijkstra algorithm.
   ///
+  ///This function also has several
+  ///\ref named-templ-func-param "named parameters",
+  ///they are declared as the members of class \ref DijkstraWizard.
+  ///The following
+  ///example shows how to use these parameters.
+  ///\code
+  ///  dijkstra(g,length,source).predMap(preds).run();
+  ///\endcode
+  ///\warning Don't forget to put the \ref DijkstraWizard::run() "run()"
+  ///to the end of the parameter list.
+  ///\sa DijkstraWizard
+  ///\sa Dijkstra
   template<class GR, class LM>
   DijkstraWizard<DijkstraWizardBase<GR,LM> >
@@ -945,6 +1042,4 @@
   }
 
-/// @}
-  
 } //END OF NAMESPACE LEMON
 
Index: src/test/bfs_test.cc
===================================================================
--- src/test/bfs_test.cc	(revision 1164)
+++ src/test/bfs_test.cc	(revision 1218)
@@ -43,5 +43,5 @@
   BType::DistMap d(G);
   BType::PredMap p(G);
-  BType::PredNodeMap pn(G);
+  //  BType::PredNodeMap pn(G);
   
   BType bfs_test(G);
@@ -54,5 +54,5 @@
   d  = bfs_test.distMap();
   p  = bfs_test.predMap();
-  pn = bfs_test.predNodeMap();
+  //  pn = bfs_test.predNodeMap();
   b  = bfs_test.reached(n);
 
Index: src/test/dfs_test.cc
===================================================================
--- src/test/dfs_test.cc	(revision 1164)
+++ src/test/dfs_test.cc	(revision 1218)
@@ -43,5 +43,5 @@
   DType::DistMap d(G);
   DType::PredMap p(G);
-  DType::PredNodeMap pn(G);
+  //  DType::PredNodeMap pn(G);
   
   DType dfs_test(G);
@@ -54,5 +54,5 @@
   d  = dfs_test.distMap();
   p  = dfs_test.predMap();
-  pn = dfs_test.predNodeMap();
+  //  pn = dfs_test.predNodeMap();
   b  = dfs_test.reached(n);
 
Index: src/test/dijkstra_test.cc
===================================================================
--- src/test/dijkstra_test.cc	(revision 1164)
+++ src/test/dijkstra_test.cc	(revision 1218)
@@ -120,6 +120,6 @@
   
   {
-    NullMap<Node,Node> myPredNodeMap;
-    dijkstra(G,cap).predNodeMap(myPredNodeMap).run(s);
+    NullMap<Node,Edge> myPredMap;
+    dijkstra(G,cap).predMap(myPredMap).run(s);
   }
   return 0;
